﻿using Microsoft.Data.Entity;


namespace WebApplicationDemo.Models
{
    public class PersonContext : DbContext
    {
        public DbSet<Person> People { get; set; }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            base.OnModelCreating(modelBuilder);

            PersonConfig.ConfigurePeson(modelBuilder);
        }
    }

    public static class PersonConfig
    {
        public static void ConfigurePeson(ModelBuilder modelBuilder)
        {
            var table = modelBuilder.Entity<Person>().ForSqlServer(p => p.Table("Person"));
            table.Property(p => p.FirstName).Required().MaxLength(30);
            table.Property(p => p.LastName).Required().MaxLength(30);
        }
    }
}
