﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNet.Builder;
using Microsoft.AspNet.Hosting;
using Microsoft.AspNet.Http;
using Microsoft.AspNet.Routing;
using Microsoft.Framework.DependencyInjection;
using WebApplicationDemo.Models;
using Microsoft.Framework.Configuration;
using Microsoft.Framework.ConfigurationModel;
using Microsoft.Data.Entity;

namespace WebApplicationDemo
{
    public class Startup
    {
        public Startup(IHostingEnvironment env)
        {
            var config = new Configuration();
            //config.AddJsonFile("config.json");
            config.AddEnvironmentVariables();
            config.Set("Data:DefaultConnection:ConnectionString", "Server=.;Database=WebAppDemo;Trusted_Connection=True;");

            Config = config;
        }

        public Microsoft.Framework.ConfigurationModel.IConfiguration Config { get; private set; }

        // This method gets called by a runtime.
        // Use this method to add services to the container
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddMvc();
            // Uncomment the following line to add Web API services which makes it easier to port Web API 2 controllers.
            // You will also need to add the Microsoft.AspNet.Mvc.WebApiCompatShim package to the 'dependencies' section of project.json.
            // services.AddWebApiConventions();

            services.AddEntityFramework()
                .AddSqlServer()
                .AddDbContext<PersonContext>(config =>
                {
                    config.UseSqlServer(Config["Data:DefaultConnection:ConnectionString"]);
                });
        }

        // Configure is called after ConfigureServices is called.
        public void Configure(IApplicationBuilder app, IHostingEnvironment env)
        {
            // Configure the HTTP request pipeline.
            app.UseStaticFiles();

            // Add MVC to the request pipeline.
            app.UseMvc();
            // Add the following route for porting Web API 2 controllers.
            // routes.MapWebApiRoute("DefaultApi", "api/{controller}/{id?}");

            using(var ctx = (PersonContext)app.ApplicationServices.GetService(typeof(PersonContext)))
            {
                ctx.Database.AsRelational().ApplyMigrations();
            }
        }
    }
}
